#!/bin/bash2
# $Id: pippage.sh,v 1.7 2000/10/23 21:23:17 schwartz Exp schwartz $
USAGE='pippage [-n num] [-c caption] [-y delta_y] [-l library] eps ... [-page eps ...]';

# -- options
ix=0;
iy=0;
dy=0;
dx=0;
caption="";
numbars=5;

declare -a libs

while getopts "c:l:n:x:y:X:Y:" c
do
    case $c in
    c) caption="$OPTARG";;
    l) libs=("${libs[@]}" "$OPTARG");;
    n) numbars="$OPTARG";;
    x) dx="$OPTARG";;
    y) dy="$OPTARG";;
    X) ix="$OPTARG";;
    Y) iy="$OPTARG";;
    \?) echo $USAGE 1>&2; exit 2;;
    esac
done
shift `expr $OPTIND - 1`

# -- main

new=1;
bar=0;
page=0;
y=$iy;
x=$ix;

pippage-header "${libs[@]}"
for f 
do
    if [[ $new -eq 1 ]]
    then
	page=$(( $page + 1 ));
	pippage-newpage $page;
	[[ -n "$caption" ]] && pippage-doeps 0 0 "$caption";
	echo New page: $page 1>&2;
    fi

    case "$f" in
    -page|-pagebreak)
        pippage-endpage; bar=0; new=1;
	echo End page: -page 1>&2;
	;;
    *)
        echo Bar: $bar 1>&2;
	pippage-doeps "$x" "$y" "$f";
	x=$(( $x + $dx ));
	y=$(( $y + $dy ));
	if [[ $(($bar+1)) -eq "$numbars" ]]
	then
            echo End page at bar $bar 1>&2;
	    pippage-endpage;
	    bar=0; new=1;
        else
	    bar=$(($bar+1)); new=0;
	fi
	;;
    esac
done
[[ $new -eq 1 ]] || pippage-endpage
pippage-end $page

