/* mlav2ascii - print a textual representation of a multiple alignment
*
* syntax:
*	mlav2ascii refine.out [name-files] [U=?]
* The U option specifies a character that is to indicate a region of the
* reference sequence that is not covered by a local alignment with the
* species assigned to the row.
*/

#include "util.h"
#include "mlav.h"
#include "args.h"

int main(int argc, char **argv)
{
	char **A, **seqname, unaligned = '-', *unal;
	int i, j, nrow, ncol;
	char buf[500];
	FILE *fp;

	argv0 = "mlav2ascii";
	if (argc < 2)
		fatal("arg = refine.out [species-name-file]* [U=#]");
	if (argv[argc-1][1] == '=') {
		ckargs("U", argc, argv, argc-2);
		if (get_cargval((int)'U', &unal)) {
			unaligned = unal[0];
			--argc;
		}
	}
	
	/* get the alignment */
	A = malign_matrix(argv[1], &nrow, &ncol, &seqname, unaligned);
	
	printf("%d %d\n", nrow, ncol);

	if (argc == 2) {
		for (i = 0; i < nrow; ++i)
			printf("%s\n", seqname[i]);
	} else {
		for (i = 2; i < argc; ++i) {
			fp = ckopen(argv[i], "r");
			fgets(buf, 500, fp);
			printf("%s", buf);
			fclose(fp);
		}
	}

	for (i = 0; i < nrow; ++i) {
		for (j = 0; j < ncol; ++j)
			putchar(A[i][j]);
		putchar('\n');
	}

	return 0;
}
