/* clip_align.c -- clip lines in an alignment file */

#include "util.h"
#include "lav.h"

enum { BUF_SIZE=500 };

int main(int argc, char **argv)
{
	char buf[BUF_SIZE], *p;
	int left_bound, right_bound, from1, from2, to1, offset = 0;
	FILE *fp;

	argv0 = "clip_align";
	if (argc != 4)
		fatal("args = blastz-output left-bound right_bound");
	align_header(1,1);

	fp = ckopen(argv[1], "r");

	if (fgets(buf, BUF_SIZE, fp) == NULL || strncmp(buf, "#:lav", 5))
		fatal("not a LAV alignment file.");

	left_bound = atoi(argv[2]);
	right_bound = atoi(argv[3]);

	if (left_bound < 0 || left_bound > right_bound)
		fatalf("improper bounds in command line.");

	while (fgets(buf, BUF_SIZE, fp)) {
		if (same_string(buf, "s {\n")) {
			fgets(buf, BUF_SIZE, fp);
			if ((p = strchr(buf+3, ' ')) == NULL ||
			    (offset = atoi(p+1)-1) < 0)
				fatal("cannot get offset.");
		}
		if (strncmp(buf, "  l ", 4) == 0) {
			if (sscanf(buf+4, "%d %d %d",&from1,&from2,&to1) != 3)
				fatal("conversion failed.");
			else if (from1 <= 0 || from1 > to1)
				/* blastz working to stay in its region */
				continue;
			else if (to1 + offset >= left_bound
			    && from1 + offset <= right_bound)
				printf("%s", buf);
		}
	}
	printf("}\n");
	fclose(fp);
	return 0;
}
