#include "util.h"
#include "arg.h"
#include "seq.h"

static const char rcsid[] = 
"$Id: seq_ident.c,v 1.2 2001/05/22 04:33:34 schwartz Exp $";

int main(int argc, char **argv)
{
    SEQ *s;
    int mflag = 0;
    int lflag = 1;

    ARGBEGIN
    {
       case 'm': mflag=1; break;
       case 'l': lflag=1; break;
       case 'M': mflag=0; break;
       case 'L': lflag=0; break;
    }
    ARGEND

    if (argc != 1)
        fatal("usage: seq");

    if ((s = seq_open(argv[0])) == 0)
        exit(1);

    while (seq_read(s)) {
    	if (lflag) printf("%d: %s\n", SEQ_LEN(s), SEQ_HEAD(s));
    	else printf("%s\n", SEQ_HEAD(s));
        if (!mflag) break;
    }
    return 0;
}
