#include "arg.h"
#include "seq.h"

static const char rcsid[] =
"$Id: seq_len.c,v 1.2 2002/08/21 22:24:33 schwartz Exp $";

int census(SEQ *s, int *nupper, int *nlower, int *ngap, int *other)
{
    int i, len;

    for (i = 0, len = SEQ_LEN(s); i < len; ++i) {
	const char c = SEQ_CHARS(s)[i];
	if (c=='n' || c=='N' || c=='x' || c=='X')
		(*ngap)++;
	else if (isupper(c))
		(*nupper)++;
	else if (islower(c))
        	(*nlower)++;
	else
		(*other)++;
    }
    return len;
}

int main(int argc, char **argv)
{
    SEQ *s;
    int mflag = 0;

    ARGBEGIN
    {
       case 'm': mflag=1; break;
    }
    ARGEND

    if (argc != 1)
        fatal("usage: seq");

    if ((s = seq_open(argv[0])) == 0)
        exit(1);

    while (seq_read(s)) {
        if (mflag) {
    	    int nupper=0, nlower=0, ngap=0, nother=0;
            int len = census(s, &nupper, &nlower, &ngap, &nother);
            printf("%d  %d %d %d\n", len, nupper, nlower, ngap);
	    assert(len == nupper+nlower+ngap+nother);
        } else {
            printf("%d\n", SEQ_LEN(s));
        }
    }
    return 0;
}
