#include "refine.h"

int main(int argc, char **argv)
{
	FILE *fp;
	int i, j, k, M, N, K, score, *LB, *RB, target_row, type_left,
		type_right, M_new;
	char buf[500];
	uchar **AL, **GC, *Seq, **AL_new;
	argv_scores_t ds;
	ss_t ss;
	int gop[256], gtype[128];


	argv0 = "yama.driver";
	if (argc != 6)
	  fatal("args = alignment_file sequence_file row left_type right_type");

	ckargs("D", argc, argv, 7);
	DNA_scores(&ds, ss);
	for (i = 0; i < 128; ++i)
		ss[i][DASH] = ss[DASH][i] = -(int)ds.E;
	ss[DASH][DASH] = 0;
	for (i = 0; i < 128; ++i)
		ss[i][FREE] = ss[FREE][i] = 0;
	gap_costs(gop, gtype, ds.O);

	target_row = atoi(argv[3]);
	type_left = atoi(argv[4]);
	type_right = atoi(argv[5]);
	

	fp = ckopen(argv[1], "r");

	fgets(buf, 500, fp);
	M = strlen(buf) - 1;	/* don't count newline */
	AL = (uchar **)ckalloc(M*sizeof(uchar *)) - 1;
	for (i = 1; i <= M; ++i) {
		AL[i] = ckalloc(10*sizeof(uchar));
		AL[i][0] = buf[i-1];
	}
	for (K = 1; fgets(buf, 500, fp); ++K) {
		if (strlen(buf) - 1 != (unsigned)M)
			fatal("Alignment has rows of unequal length.");
		for (i = 1; i <= M; ++i)
			AL[i][K] = buf[i-1];
	}
	GC = (uchar **)ckalloc((M+1)*sizeof(uchar *));
	for (i = 0; i <= M; ++i)
		GC[i] = (uchar *)ckalloc(10*sizeof(uchar));
	for (i = 0; i <= M; ++i)
		for (k = 0; k < K; ++k)
			GC[i][k] = DASH;
	GC[0][1] = FREE;
	printf("Alignment:\n");
	for (k = 0; k < K; ++k) {
		for (i = 1; i <= M; ++i)
			putchar(AL[i][k]);
		putchar('\n');
	}
	fclose(fp);
	fp = ckopen(argv[2], "r");
	fgets(buf, 500, fp);
	N = strlen(buf) - 1;	/* don't count newline */
	Seq = (uchar *)ckalloc(N*sizeof(uchar)) - 1;
	for (j = 1; j <= N; ++j)
		Seq[j] = buf[j-1];
	printf("\nSequence:\n");
	for (j = 1; j <= N; ++j)
		putchar(Seq[j]);
	putchar('\n');
	putchar('\n');

	LB = ckalloc((M+1)*sizeof(int));
	RB = ckalloc((M+1)*sizeof(int));
	for (i = 0; i <= M; ++i) {
		LB[i] = 0;
		RB[i] = N;
	}
		
	score = row_yama(AL, GC, K, M, Seq, N, type_left, type_right, LB, RB,
		ss, gop, gtype, target_row, &AL_new, &M_new);
	printf("yama = %d\n", score);
	score = row_score(AL_new, K+1, M_new, target_row, ss, gop, gtype);
	printf("real score = %d\n", score);

	free(Seq+1);
	for (i = 1; i <= M; ++i)
		free(AL[i]);
	free(AL+1);
	free(LB);
	free(RB);
	for (k = 0; k <= K; ++k) {
		for (i = 1; i <= M_new; ++i)
			putchar(AL_new[i][k]);
		putchar('\n');
	}
	free(AL_new[1]);
	free(AL_new+1);
	
	free(GC[0]);
	free(GC);
	
	return 0;
}
